﻿namespace TestProject;

/// <summary>
/// 베이스 페이지
/// </summary>
public abstract class BasePage : ContentPage
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
    ////////////////////////////////////////////////////////////////////////////////////////// Protected

    #region 생성자 - BasePage(viewModel)

    /// <summary>
    /// 생성자
    /// </summary>
    /// <param name="viewModel">뷰 모델</param>
    protected BasePage(object viewModel = null)
    {
        BindingContext = viewModel;

        if(string.IsNullOrWhiteSpace(Title))
        {
            Title = GetType().Name;
        }
    }

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Method
    ////////////////////////////////////////////////////////////////////////////////////////// Protected

    #region 페이지가 나타나는 경우 처리하기 - OnAppearing()

    /// <summary>
    /// 페이지가 나타나는 경우 처리하기
    /// </summary>
    protected override void OnAppearing()
    {
        base.OnAppearing();

        // 추후 기능을 추가한다.
    }

    #endregion
    #region 페이지가 사라지는 경우 처리하기 - OnDisappearing()

    /// <summary>
    /// 페이지가 사라지는 경우 처리하기
    /// </summary>
    protected override void OnDisappearing()
    {
        base.OnDisappearing();

        // 추후 기능을 추가한다.
    }

    #endregion
}

/// <summary>
/// 베이스 페이지
/// </summary>
/// <typeparam name="TViewModel">뷰 모델 타입</typeparam>
public abstract class BasePage<TViewModel> : BasePage where TViewModel : BaseViewModel
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Property
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region 바인딩 컨텍스트 - BindingContext

    /// <summary>
    /// 바인딩 컨텍스트
    /// </summary>
    public new TViewModel BindingContext => (TViewModel)base.BindingContext;

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
    ////////////////////////////////////////////////////////////////////////////////////////// Protected

    #region 생성자 - BasePage(viewModel)

    /// <summary>
    /// 생성자
    /// </summary>
    /// <param name="viewModel">뷰 모델</param>
    protected BasePage(TViewModel viewModel) : base(viewModel)
    {
    }

    #endregion
}